Package org.apache.bcel.classfile

# Class SourceFile

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.SourceFile

All Implemented Interfaces:
  `Cloneable`, `Node`

public final class SourceFile extends Attribute
This class is derived from Attribute and represents a reference to the source file of this class. At most one SourceFile attribute should appear per classfile. The intention of this class is that it is instantiated from the Attribute.readAttribute() method.

See Also:
  - `Attribute`

- ## Field Summary

  ### Fields inherited from class org.apache.bcel.classfile.Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SourceFile(int nameIndex, int length, int sourceFileIndex, ConstantPool constantPool)`
  `SourceFile(SourceFile c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  `void`
  `dump(DataOutputStream file)`
  Dump source file attribute to file stream in binary format.
  `int`
  `getSourceFileIndex()`
  `String`
  `getSourceFileName()`
  `void`
  `setSourceFileIndex(int sourceFileIndex)`
  `String`
  `toString()`

  ### Methods inherited from class org.apache.bcel.classfile.Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### SourceFile

    public SourceFile(int nameIndex, int length, int sourceFileIndex, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8, which should represent the string "SourceFile".
      `length` - Content length in bytes, the value should be 2.
      `sourceFileIndex` - Index in constant pool to CONSTANT_Utf8. This string will be interpreted as the name of the file from which this class was compiled. It will not be interpreted as indicating the name of the directory contqining the file or an absolute path; this information has to be supplied the consumer of this attribute - in many cases, the JVM.
      `constantPool` - The constant pool that this attribute is associated with.

  - ### SourceFile

    public SourceFile(SourceFile c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump source file attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getSourceFileIndex

    public int getSourceFileIndex()
    Returns:
      Index in constant pool of source file name.

  - ### getSourceFileName

    public String getSourceFileName()
    Returns:
      Source file name.

  - ### setSourceFileIndex

    public void setSourceFileIndex(int sourceFileIndex)
    Parameters:
      `sourceFileIndex` -

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation